<template>
  <div>
    <v-container>
      <v-row>
        <v-col :cols="12" :xl="6">
          <div class="form-group">
            <label for="connect">WebSocket connection:</label>
            <v-spacer></v-spacer>
            <v-btn color="blue" :disabled="connected" @click.prevent="connect"
              >Connect</v-btn
            >
            <v-btn
              class="ml-10"
              color="green"
              :disabled="!connected"
              @click.prevent="disconnect"
              >Disconnect</v-btn
            >
            <v-btn
              class="ml-10"
              color="yellow"
              :disabled="!connected"
              @click.prevent="sendActionsConnectLogs"
              >Connect Logs</v-btn
            >
          </div>
        </v-col>
        <v-col :xl="6">
          <div class="form-group">
            <label for="text">Message</label>
            <v-text-field
              v-model="text"
              placeholder="Message..."
              :disabled="!connected"
              @keyup.enter="sendName"
            ></v-text-field>
          </div>
          <v-btn :disabled="!connected" color="green" @click.prevent="sendName"
            >Send</v-btn
          >
        </v-col>
      </v-row>
      <v-row>
        <v-col :cols="12" :xl="12">
          <table id="conversation" class="table table-striped">
            <thead>
              <tr>
                <th>Messages WS</th>
                <th>
                  <v-btn class="ml-10" color="orange" @click.prevent="crearLogs"
                    >Limpiar</v-btn
                  >
                </th>
              </tr>
            </thead>
            <tbody id="greetings">
              <tr
                v-for="(message, indexMessage) in messages"
                :key="indexMessage"
              >
                <td colspan="2">{{ message }}</td>
              </tr>
            </tbody>
          </table>
        </v-col>
      </v-row>
    </v-container>
  </div>
</template>
<script>
import Stomp from "webstomp-client";
import SockJS from "sockjs-client";
import store from "@/store";
export default {
  name: "Component-SocketClient",
  data() {
    return {
      stompClient: null,
      text: null,
      messages: [],
      connected: false
    };
  },
  methods: {
    setConnected(connected) {
      this.connected = connected;
    },
    connect() {
      console.log(store.state.urlWebSocketPlataformaFranquicia);
      const self = this;
      const socket = new SockJS(store.state.urlWebSocketPlataformaFranquicia);
      this.stompClient = Stomp.over(socket);
      this.stompClient.debug = function(str) {};
      this.reconnect_delay = 5000;
      this.stompClient.connect(
        {},
        function(frame) {
          self.setConnected(true);
          console.log("Connected: " + frame);
          self.stompClient.subscribe("/topic/chat", function(greeting) {
            self.messages.push(JSON.parse(greeting.body));
          });
          self.stompClient.subscribe("/queue/errors", function(error) {
            console.log(error);
          });
          self.stompClient.subscribe("/topic/logs", function(logs) {
            self.messages.push(JSON.parse(logs.body));
          });
          self.stompClient.subscribe("/topic/actions", function(logs) {
            self.messages.push(JSON.parse(logs.body));
          });
        },
        function(message) {
          self.disconnect();
          setTimeout(self.connect, 5000);
        }
      );
    },
    crearLogs() {
      this.messages = [];
    },
    disconnect() {
      if (this.stompClient !== null) {
        this.stompClient.disconnect();
      }
      this.setConnected(false);
    },
    sendName() {
      let message = JSON.stringify({
        text: this.text
      });
      this.text = null;
      this.stompClient.send("/app/chat", message);
    },
    sendActionsConnectLogs() {
      let actions = JSON.stringify([
        {
          action: "SELF_CONNECT"
        },
        {
          action: "NODES_CONNECT"
        }
      ]);
      this.stompClient.send("/app/actions", actions);
    }
  },
  created() {
    this.connect();
  }
};
</script>
